unit strbit32;
{$R-}
interface
{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
{                                          }
{   p 7.2                  29.06.2004.                  }
{  32  pp   DELPHI 2.0 - 7.0  }
{       486         }
{  pp                          }
{_______________________________________1999 - 2004 .________}
{    p p  ,          }
{        p  p:                          }
{    :  76543210          - p            }
{   :  111111                                            }
{           5432109876543210  - p            }
{   :         111111  22221111 ...  - p      }
{           765432105432109832109876 ...              }
{           ! 1 ! 2 ! 3 !                         }
{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
{  :                                     }
{      :         0 - 1073741823 }
{             }
{          ,  }
{   ,               }
{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

uses SysUtils, Consts, Classes, Windows;

const
   bt1 : byte = 1;     { "1"               }
   bt0 : byte = 0;     { "0"               }
   btNotFound = -1;    { p   }
   btAND : Byte = 1;   { p AND         }
   btXOR : Byte = 0;   { p XOR         }
   btOR  : Byte = 2;   { p OR          }
   btCreate   : word =  $3C00; { p ,     }
   btOpenRead : word =  $3D00; {p ,    }
   btOk      = 0; {               }
   btNeop    = 2; {  p p      }
   btNevReg  = 4; { p p      }
   btOchBB   = 5; {  p - /  }
   btEndFile =  9;     {     }
   bt8  = 8192;
   bt16 = 16384;
   bt32 = 32768;
   bt64 = 65536;
   bt128 = 131072;
   btVnBuf = 65536;  {       }
Type
{ Exception classes }
EStrBitError = class(Exception);
EFileBitError = class(Exception);
EFileBitZacr = class(Exception);

 TStr_Bit = class
{!!!         Integer }
{          1073741823    }
{                 }
{  ,        }
  private
    FSize: Integer;
    FBits: PByte;
    procedure Error;
    procedure SetSize(Value: Integer);
    procedure SetBit(Index: Integer; Value: Byte);
    function GetBit(Index: Integer): Byte;
    procedure Upak ( N : Integer; Mis: PByte );
 {  N  p  c,p  Mis  }
 {         }
 {    Mis                                         }
    procedure Init_zn (Razm: Integer; value: Byte);
    procedure ReplaceGrBt(Index, Kol, Value: Integer);
 {  Kol  p (<=32),    Index        }
 {   c,p  Value                         }

  public   {        }

    Procedure InvBit ( Index : Integer);
 { pp  p   Index}
    procedure Init_1 (Razm: Integer);   {    p  "1" }
    procedure Init_0 (Razm: Integer);   {    p  "0" }
    procedure Init_Sim(Ust :string);
 {  p  c,p p }
    procedure Init_Mas(Kol: Integer; var MasBt);
 {  Kol  p  c,p  Mas }
 {   p p bt1  bt0                          }
    procedure Init_array (var Ust; Kol : Integer);
 {   p  c,p p Ust }
 {  p Kol  p  p p       }
    function Val_sim: string;
 { pp  p    ("1""0") }
    function Val_Mas(Kol: Integer; var MasBt): Integer;
 {    Mas   bt1  bt0,        }
 { p  p  (p p p) }
 {       p-      }
  procedure Val_array ( var Mass; Kol: Integer);
   { p p Kol   p    }
   {    p  pp ,     }
   {                       }
    procedure Copy ( Isx : TStr_Bit; Index,Count: Integer);
 {   p  ,    Isx  }
 {   Index   Count                                       }
    procedure CopyAllBit ( Isx : TStr_Bit);
 {   p    Isx  }
    procedure Concat ( Dopoln : TStr_Bit);
 {    p  p Dopoln (  )   }
    procedure BOOL ( Dopoln : TStr_Bit; Vid_op: Byte);
 {       ,        }
 {   Vid_op   p  p           }
 {      ,     }
 {      2                                      }
 {    Vid_op:                 }
 {        p AND   Vid_op:= btAND : Byte = 1;      }
 {        p XOR   Vid_op:= btXOR : Byte = 0;      }
 {        p OR    Vid_op:= btOR  : Byte = 2;      }
    procedure InvStrBit;
 {   .  "1"  0   }
    function Nomer(Nach : Integer; dln: byte) : Integer;
 {     Dln       Nach.
      ,    DLN
    .          - 32             }
    procedure Mod2( Dopoln : TStr_Bit);
 {       2    }
    function Kol_ed : Integer;
 {    1    }
    function ModReg( VidReg : TStr_Bit ) : byte;
 {  p p  mod 2   pp,  }
 {  p VidReg.  p  p bt1  bt0     }
    function Pos(SubS: TStr_Bit; Nach, Shag : Integer ): Integer;
 { p ,   p   p p p SubS; }
 {     Nach,   p         }
 {      Shag.                                  }
 {        btNotFound = -1         }
    procedure Delete (Index,Count: Integer);
 {  Count    p,    Index }
    procedure Insert (Dopoln : TStr_Bit; Index: Integer);
 { p Dopoln   p,   Index}
    procedure BitDisplase (Zn: byte);
 {    Zn     - }
 { (       1  )    }
 {                           }
 { (        )    }
    procedure LastBitDisplase (Zn: byte);
 {    Zn     - }
 { (       1  )      }
 {  ( = 0)                  }
 { (        )      }
    procedure Rotate (Val: integer);
 {            }
 {   Val                                             }
 { (        )      }
    procedure Replace (Dopoln : TStr_Bit; Index: Integer);
 {   ,   Index,   }
 {    Dopoln                                  }
    constructor Create;
    destructor Destroy; override;
    function OpenBit: Integer; {      }
    property Bits[Index: Integer]: Byte read GetBit write SetBit; default;
    {        }
    property Size: Integer read FSize write SetSize;
    {      }
  end;

TCustomBitFile = class(TStr_Bit)
  private
    FFileHandle: THandle; //   
    FMapHandle: THandle;
    FData: PByte;  //      
   FOrderBitRevers: boolean; {   /   }
   FDisFile : file;
   FPosBuf,      {  p    p}
   FPosBufMax,   {  p   }
   FRazmBuf,FRegOtkr : Integer;
   FBuff : PByte;    {    p }
   FStateI0 : Integer; {   / }
    procedure FileError;
    procedure FileErrorZacr;
  public
    constructor Create;
    destructor Destroy; override;
    property StateI0: Integer read FStateI0;
  protected
    procedure CloseBitFile; virtual; abstract;
end;

 TBitFile = class(TCustomBitFile)
  private
   FPosition,    {  p     }
   FFileSize,    {     }
   FPosMax : Integer;  {     }
  public
    constructor Create;
    destructor Destroy; override;
    procedure OpenBitFile (Name: string; Mode: word);
  { Name  -  ,  p  p p    }
  { Mode  - p p                                        }
  {btCreate   - p ,                        }
  {btOpenRead - p ,                      }
    procedure CloseBitFile;  override;
  {     }
    procedure ChangeOrderBit;
   {         . }
   { !!!        !               }
   {   :      }
   { !!!!            }
   {       ,   . }
    function ReadStr(Count:Integer): word;
   {  Count  p    }
    function ReadBit: Byte;
   {    ,   >1 =>  -  }
    function ReadNomer(Dln:byte): Integer;
   {     DLN      - }
    function WriteStr: word;
   {  p      }
    function WriteBit(Zn:byte): word;
   {  Zn     }
    function WriteNomer(Zn:integer; Dln:byte): word;
   {     DLN      -  }
    function SeekStr(Polog : longint): word;
   {         Polog }
    function SizeOfFile : longint;
   { p  pp    }
  protected
    function VnWriteBuf(Count: Integer; AdrIsx:PByte): Word;
  end;

 TBitFileLong = class(TCustomBitFile)
  private
   FPosition,    {  p     }
   FPosMax : Int64;  {     }
  public
    constructor Create;
    destructor Destroy; override;
    procedure OpenBitFile (Name: string; Mode: word; BufSize: Integer);
  { Name  -  ,  p  p p    }
  { Mode  - p p                                        }
  {btCreate   - p ,                        }
  {btOpenRead - p ,                      }
  { BufSize  - pp p p      }
{          }
{    ,     8,}
{     8192                            }
{        }
{ bt8, bt16, bt32, bt64, bt128 -     }
{  8,16,32,64, 128                            }
    procedure CloseBitFile;  override;
  {     }
    procedure ChangeOrderBit;
   {         . }
   { !!!        !               }
   {   :      }
   { !!!!            }
   {       ,   . }
    function ReadStr(Count:Integer): word;
   {  Count  p    }
    function ReadBit: Byte;
   {    ,   >1 =>  -  }
    function ReadNomer(Dln:byte): Integer;
   {     DLN      - }
    function WriteStr: word;
   {  p      }
    function WriteBit(Zn:byte): word;
   {  Zn     }
    function WriteNomer(Zn:integer; Dln:byte): word;
   {     DLN      -  }
    function SeekStr(Polog : Int64): word;
   {         Polog }
    function SizeOfFile : Int64;
   { p  pp    }
  protected
    function VnReadBuf(Count: Integer; AdrItog:PByte): Word;
    function VnWriteBuf(Count: Integer; AdrIsx:PByte): Word;
  end;

implementation

const
  BitsPerInt = SizeOf(Integer) * 8;
  Tabob : array [0..255] of byte =
     ($00,$80,$40,$0C0,$20,$0A0,$60,$0E0,$10,$90,$50,$0D0,$30,$0B0,$70,$0F0,
      $08,$88,$48,$0C8,$28,$0A8,$68,$0E8,$18,$98,$58,$0D8,$38,$0B8,$78,$0F8,
      $04,$84,$44,$0C4,$24,$0A4,$64,$0E4,$14,$94,$54,$0D4,$34,$0B4,$74,$0F4,
      $0C,$8C,$4C,$0CC,$2C,$0AC,$6C,$0EC,$1C,$9C,$5C,$0DC,$3C,$0BC,$7C,$0FC,
      $02,$82,$42,$0C2,$22,$0A2,$62,$0E2,$12,$92,$52,$0D2,$32,$0B2,$72,$0F2,
      $0A,$8A,$4A,$0CA,$2A,$0AA,$6A,$0EA,$1A,$9A,$5A,$0DA,$3A,$0BA,$7A,$0FA,
      $06,$86,$46,$0C6,$26,$0A6,$66,$0E6,$16,$96,$56,$0D6,$36,$0B6,$76,$0F6,
      $0E,$8E,$4E,$0CE,$2E,$0AE,$6E,$0EE,$1E,$9E,$5E,$0DE,$3E,$0BE,$7E,$0FE,
      $01,$81,$41,$0C1,$21,$0A1,$61,$0E1,$11,$91,$51,$0D1,$31,$0B1,$71,$0F1,
      $09,$89,$49,$0C9,$29,$0A9,$69,$0E9,$19,$99,$59,$0D9,$39,$0B9,$79,$0F9,
      $05,$85,$45,$0C5,$25,$0A5,$65,$0E5,$15,$95,$55,$0D5,$35,$0B5,$75,$0F5,
      $0D,$8D,$4D,$0CD,$2D,$0AD,$6D,$0ED,$1D,$9D,$5D,$0DD,$3D,$0BD,$7D,$0FD,
      $03,$83,$43,$0C3,$23,$0A3,$63,$0E3,$13,$93,$53,$0D3,$33,$0B3,$73,$0F3,
      $0B,$8B,$4B,$0CB,$2B,$0AB,$6B,$0EB,$1B,$9B,$5B,$0DB,$3B,$0BB,$7B,$0FB,
      $07,$87,$47,$0C7,$27,$0A7,$67,$0E7,$17,$97,$57,$0D7,$37,$0B7,$77,$0F7,
      $0F,$8F,$4F,$0CF,$2F,$0AF,$6F,$0EF,$1F,$9F,$5F,$0DF,$3F,$0BF,$7F,$0FF );
  SumKod  : array [0..255] of byte =
    (0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4, 1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
     1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5, 2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
     1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5, 2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
     2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6, 3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
     1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5, 2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
     2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6, 3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
     2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6, 3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
     3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7, 4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8);

type
  TBitEnum = 0..BitsPerInt - 1;
  TBitSet = set of TBitEnum;
  PBitArray = ^TBitArray;
  TBitArray = array[0..4096] of TBitSet;
Var
  btTabob, btSumKod : PByte;

procedure MovBit( NBis,Kol,NBrez : Integer; mis,mrez : PByte);
  near;  assembler;
{ pp  KOL     p MIS   NBIS }
{     MREZ   MBREZ                         }
ASM
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX
        MOV     ESI,Mis         { p      }
        MOV     EDI,Mrez        { p  p   }
        CLD
{  EAX -->    - NBis           }
{  EDX -->    - Kol - Ko p  }
{  ECX -->    - NBrez          }
         mov     EBX,ECX
         shr     ECX,3
         add     EDI,ECX
         and     EBX,7          { p p  }
         jz      @GRAN          { p  ?       }

         neg     bl
         add     bl,8           {   }
         PUSH    EAX       {NBis}
         shr     EAX,3
         add     ESI,EAX         { p p   }
         lodsw                  {               }
         POP     ECX       {NBis}
         MOV     BH,CL     {   NBis}
         and     cl,7
         ror     ax,cl          { p  p  }
         mov     cl,bl
         mov     ah,[EDI]
         shl     ah,cl          {   p }
         ror     ax,cl
         mov     al,ah
         stosb
         mov     CL,BH     {   NBis}
         MOV     EAX,ECX   { Nbis }
         XOR     BH,BH     {      }
         sub     EDX,EBX   {  -  }
         jbe     @Finis
         add     EAX,EBX   {    p }
         MOV     ESI,Mis   { p   }

@GRAN:   add     EDX,7
         shr     EDX,3
         JZ      @Finis
         MOV     CX,AX
         shr     EAX,3
         add     ESI,EAX
         and     cl,7           {   p  }
         jnz     @Povt          { p  ?             }

         mov     ECX,EDX          {  }
  rep    movsb
         jmp     @Finis
@Povt:                          {  }
         mov     ax,[esi]
         ror     ax,cl
         stosb
         inc     ESI
         dec     EDX
         jnz     @Povt         {  p  }
@Finis:
        POP     EBX
        POP     ESI
        POP     EDI    {   /    }
END;

procedure OrderBit(Mreor : PByte; KolBayt : integer);  assembler;
{                          }
{  EAX -->    - Mreor                  }
{  EDX -->    - KolBayt                }
ASM
     PUSH    EDI
     PUSH    EBX
     mov     ECX,EDX
     MOV     EDI,EAX
     MOV     EBX,btTabob
     XOR     EAX,EAX
@cicl:
     MOV     AL,[EDI]
     MOV     AL,[EBX+EAX]
     STOSB
     loop    @cicl
     pop    EBX
     pop    EDI
END;

function Min(X, Y: Integer): Integer;
begin
    if X > Y then Result := Y else Result := X;
end;

constructor TStr_Bit.Create;
begin
  inherited Create;
  FSize := 0;
  FBits := nil;
end;

destructor TStr_Bit.Destroy;
begin
  SetSize(0);
  inherited Destroy;
end;

procedure TStr_Bit.Error;
begin
  raise EStrBitError.Create(SBitsIndexError);
end;

procedure TStr_Bit.SetSize(Value: Integer);
 {        ( )}
 {   ,     }
var
  NewMem: PByte;
  NewMemSize: Integer;
  OldMemSize: Integer;
begin
  if Value <> Size then
  begin
    if Value < 0 then Error;
    NewMemSize := ((Value + BitsPerInt - 1) div BitsPerInt) * SizeOf(Integer);
    OldMemSize := ((Size + BitsPerInt - 1) div BitsPerInt) * SizeOf(Integer);
    if NewMemSize <> OldMemSize then
    begin
      NewMem := nil;
      if NewMemSize <> 0 then  GetMem(NewMem, NewMemSize);
      if OldMemSize <> 0 then
      begin
        if NewMem <> nil then
          Move(FBits^, NewMem^, Min(OldMemSize, NewMemSize));
        FreeMem(FBits, OldMemSize);
      end;
      FBits := NewMem;
    end;
    FSize := Value;
  end;
end;


procedure TStr_Bit.SetBit(Index: Integer; Value: Byte); assembler;
 {       Index }
asm
        CMP     Index,[EAX].FSize
        JAE     @@Size

@@1:    MOV     EAX,[EAX].FBits
        OR      Value,Value
        JZ      @@2
        BTS     [EAX],Index
        RET

@@2:    BTR     [EAX],Index
        RET

@@Size: CMP     Index,0
        JL      TStr_Bit.Error
        PUSH    Self
        PUSH    Index
        PUSH    ECX {Value}
        INC     Index
        CALL    TStr_Bit.SetSize
        POP     ECX {Value}
        POP     Index
        POP     Self
        JMP     @@1
end;

function TStr_Bit.GetBit(Index: Integer): Byte; assembler;
 {   p   Index }
 {  EDX -->    - Index -     }
asm
        CMP     EDX,[EAX].FSize
        JAE     TStr_Bit.Error
        MOV     EAX,[EAX].FBits
        BT      [EAX],EDX
        SBB     EAX,EAX
        AND     EAX,1
end;

procedure TStr_Bit.BitDisplase (Zn: byte);               assembler;
 {    Zn     - }
 { (       1  )    }
 {                           }
 { (        )    }
 {  EDX -->    - Zn -            }
asm
        PUSH    EDI
        MOV     ECX,[EAX].FSize      {               }
        MOV     EDI,[EAX].FBits      { p   p  }
        ADD     ECX,15
        shr     ECX,4    {      }
        JZ      @NetDan
        CLD              {     }
        SHR     DL,1     {    (0 ) }
@sdv:   MOV     AX,[EDI]
        RCL     AX,1
        STOSW            {   }
        LOOP    @sdv
@NetDan:
        POP     EDI
end;

procedure TStr_Bit.LastBitDisplase (Zn: byte);           assembler;
 {    Zn     - }
 { (       1  )      }
 {  ( = 0)                  }
 { (        )      }
 {  EDX -->    - Zn -              }
ASM
     PUSH    EDI
     MOV    ECX,[EAX].FSize      {                }
     SUB    ECX,1                {            }
     JB     @NetDann             {      }
     CLD             {     }
     MOV    DH,CL    {     }
     MOV    EDI,[EAX].FBits      { p   p  }
     SHR    ECX,4                {    }
     JZ    @OdinWord
@SdNach:        {      }
       MOV  EAX,[EDI]
       SHR  EAX,1
       STOSW
       LOOP @SdNach
@OdinWord:       {    }
        mov     CL,DH           //    
        AND     CL,00001111b    //   
        JZ      @1bit
        MOV     AX,[EDI]
        SHR     AX,1
        MOV     [EDI],AX
@1bit:  OR      DL,DL     {     }
        JZ      @@2
        BTS     [EDI],ECX
        JMP     @NetDann
@@2:    BTR     [EDI],ECX
@NetDann:
        POP     EDI
END;

function TStr_Bit.ModReg( VidReg : TStr_Bit ) : byte;         assembler;
{  p p  mod 2   pp VidReg,  }
{   p.  p  p bt1  bt0  }
{  EDX -->    - VidReg -        }
    ASM
     PUSH   EDI
     PUSH   ESI
     MOV    ESI,[EAX].FBits   { p     }
     MOV    ECX,[EAX].FSize   {         }
     MOV    EDI,[EDX].FBits   { p  p  pp }
     mov    EAX,[EDX].FSize   {     pp }
     cmp    ECX,EAX
     JLE    @SizeRegBig
     MOV    ECX,EAX          {      }
@SizeRegBig:       {        }
     MOV    DL,CL  {      }
     CLD             {     }
     XOR    DH,DH     {      mod 2 }
      SHR     ECX,3  {     pp}
      JZ      @OdinByte
@Povt:
      LODSB
      AND     AL,[EDI]
      XOR     DH,AL
      inc     EDI
      LOOP    @Povt
@OdinByte:           { p   }
     AND     DL,7
     JZ      @NetBit
     MOV     cl,8
     SUB     CL,DL  { -    }
     LODSB
     AND     AL,[EDI]
     SHL     AL,CL
     XOR     DH,AL
@NetBit:
     xor     EAX,EAX
     xor     DH,AL
     jp      @NEX              { p  }
     inc     ax                { p p al}
@NEX: POP     ESI
      POP     EDI
END;

function TStr_Bit.OpenBit: Integer;
 {      }
var
  I: Integer;
  B: TBitSet;
  J: TBitEnum;
  E: Integer;
begin
  E := (Size + BitsPerInt - 1) div BitsPerInt - 1;
  for I := 0 to E do
    if PBitArray(FBits)^[I] <> [0..BitsPerInt - 1] then
    begin
      B := PBitArray(FBits)^[I];
      for J := Low(J) to High(J) do
      begin
        if not (J in B) then
        begin
          Result := I * BitsPerInt + J;
          if Result >= Size then Result := Size;
          Exit;
        end;
      end;
    end;
  Result := Size;
end;

Procedure TStr_Bit.InvBit ( Index : Integer);  assembler;
 { pp  p   Index}
 {  EDX -->    - Index -     }
asm
     CMP   EDX,[EAX].FSize
     JAE   TStr_Bit.Error
     MOV   EAX,[EAX].FBits
     btc   [EAX],EDX
end;

procedure TStr_Bit.Upak ( N : Integer; Mis: PByte );     assembler;
 { pp  N     p MIS,  p }
 {  p                          }
 {         MREZ             }
 {  EDX -->    - N -       }
 {  ECX -->    - Mis -      }
asm
        CMP     N,[EAX].FSize
        JNE     @@Size
@@1:    PUSH    EDI
        PUSH    ESI
        MOV     ESI,Mis           {  p  }
        MOV     EDI,[EAX].FBits   {  p   }
        MOV     ECX,N
        add     ECX,7
        shr     ECX,3
        cld
@povt:  lodsb
        ror     ax,1
        lodsb
        ror     ax,1
        lodsb
        ror     ax,1
        lodsb
        ror     ax,1
        lodsb
        ror     ax,1
        lodsb
        ror     ax,1
        lodsb
        ror     ax,1
        lodsb
        ror     ax,1
        MOV     [EDI],AH
        INC     EDI
        loop    @povt
        POP     ESI
        POP     EDI
        RET               {    }

@@Size: CMP     N,0
        JL      TStr_Bit.Error
        PUSH    Self
        PUSH    N
        PUSH    Mis
        CALL    TStr_Bit.SetSize
        POP     Mis
        POP     N
        POP     Self
        JMP     @@1
end;

procedure TStr_Bit.Init_Sim (Ust :string);
{  p  c,p p }
begin
   if length(Ust) <> 0 then Upak ( length(Ust), @Ust[1] )
                       else SetSize(0);
end;

function TStr_Bit.Val_sim: string;
   { pp  p    }
var i : Integer;       S_Sim : String;
begin
 S_sim := '';
 if Size > 0 then for i := 0 to Size-1 do
    S_sim := S_sim + Chr( Bits[i] + ord('0') );
 Val_sim := S_sim;
end;

procedure TStr_Bit.Init_Mas(Kol: Integer; var MasBt);
 {  Kol  p  c,p  Mas }
 {   p p bt1  bt0                          }
begin
  Upak ( Kol, @MasBt )
end;

function TStr_Bit.Val_Mas(Kol: Integer; var MasBt): Integer;  assembler;
 {    Mas   bt1  bt0,        }
 { p  p  (p p p) }
 {       p-      }
asm
        PUSH    EDI
        PUSH    ESI
        mov     ESI,[EAX].FBits
        mov     EDI,MasBt
        CMP     Kol,[EAX].FSize
        JB      @@1
        MOV     EDX,[EAX].FSize
@@1:    MOV     ECX,EDX
        cld
        xor     al,al
@povt:
        mov     ah,[esi]
        shr     ax,1
        rol     al,1
        STOSB           {1}
        DEC     ECX
        jz      @kon
        shr     ax,1
        rol     al,1
        STOSB           {2}
        DEC     ECX
        jz      @kon
        shr     ax,1
        rol     al,1
        STOSB           {3}
        DEC     ECX
        jz      @kon
        shr     ax,1
        rol     al,1
        STOSB           {4}
        DEC     ECX
        jz      @kon
        shr     ax,1
        rol     al,1
        STOSB           {5}
        DEC     ECX
        jz      @kon
        shr     ax,1
        rol     al,1
        STOSB           {6}
        DEC     ECX
        jz      @kon
        shr     ax,1
        rol     al,1
        STOSB           {7}
        DEC     ECX
        jz      @kon
        shr     ax,1
        rol     al,1
        STOSB           {8}
        DEC     ECX
        jz      @kon
        inc     ESI
        jmp     @povt
@kon:   MOV     EAX,EDX
        POP     ESI
        POP     EDI
end;

procedure TStr_Bit.Concat ( Dopoln : TStr_Bit);
   {    p  p Dopoln      }
var OldSize : Integer;
begin
   if Dopoln.FBits = nil then Exit;
   OldSize := Size;
   SetSize(OldSize + Dopoln.Size);
   MovBit (0, Dopoln. Size, OldSize, Dopoln.FBits, FBits);
end;

procedure TStr_Bit.Delete (Index,Count: Integer);
   {  Count    p,    Index }
   {    Index   }
Var I : integer;
begin
  if (Count < 1) or (Index < 0) then Error;
  I := Count+Index;
  if  i >= Size
   then SetSize(Index)
   else begin
   MovBit(I, Size-I, Index, FBits, FBits );
   SetSize(Size-Count);
end     end;

procedure TStr_Bit.Rotate(Val: integer);
 {            }
 {   Val                                             }
 { (        )      }
Var VnSdv, MemSize : Integer;
    NewMem: PByte;
begin
 VnSdv := (Size - Val) mod Size;
 if (VnSdv = 0) or (Size<1) then Exit;
  MemSize := ((Size + BitsPerInt - 1) div BitsPerInt) * SizeOf(Integer);
  GetMem (NewMem, MemSize);
  MovBit (VnSdv, Size-VnSdv, 0, FBits, NewMem );
  MovBit (0, VnSdv, Size-VnSdv, FBits, NewMem );
  FreeMem (FBits, MemSize);
  FBits := NewMem;
end;

procedure TStr_Bit.Insert (Dopoln : TStr_Bit; Index: Integer);
{ p Dopoln   p,   Index}
var NewMem: PByte;
    Value, MemSize: Integer;
begin
  if Index > Size then Error;
  if Dopoln.FBits = nil then Exit;
  If (Size = 0) or (Size = Index)
   then Concat(Dopoln)
   else begin
    Value := Size + Dopoln.Size;
    MemSize := ((Value + BitsPerInt - 1) div BitsPerInt) * SizeOf(Integer);
    GetMem(NewMem, MemSize);
       {     }
    if Index <> 0 then MovBit(0, Index, 0, FBits, NewMem );
    MovBit(0, Dopoln.Size, Index, Dopoln.FBits, NewMem );
    MovBit(Index, Size-Index, Index+Dopoln.Size, FBits, NewMem );
       {       }
    MemSize := ((Size + BitsPerInt - 1) div BitsPerInt) * SizeOf(Integer);
    FreeMem(FBits, MemSize);
    FBits := NewMem;
    FSize := Value;
end     end;

procedure TStr_Bit.ReplaceGrBt(Index, Kol, Value: Integer); assembler;
 {  Kol  p (<=32),    Index        }
 {   c,p  Value                         }
{  EDX -->    - Index -   .     }
{  ECX -->    - Kol   -     }
asm
        PUSH    ESI
        MOV     ESI,Value
        MOV     EAX,[EAX].FBits
@@1:    SHR     Value,1
        JNC      @@2
        BTS     [EAX],EDX
        JMP     @@3
@@2:    BTR     [EAX],EDX
@@3:    INC     EDX
        LOOP    @@1
        POP     ESI
end;

procedure TStr_Bit.Replace (Dopoln : TStr_Bit; Index: Integer);
 {    ,   Index,   }
 {    Dopoln                                   }
var Value, Gran, Ostat, Znach : Integer;
begin
 if (Index > Size) or (Dopoln.Size = 0) then Error; {  }
 Ostat := Index + Dopoln.Size;
 if Ostat > Size
  then begin   {       }
   SetSize(Ostat);
   MovBit(0, Dopoln.Size, Index, Dopoln.FBits, FBits );
      end
  else begin
   Gran := (Ostat div 8) * 8;
   If (Dopoln.Size < 8) and (Gran <= Index )
     then begin   {        }
      ASM
      MOV  EAX,Dopoln
      mov  EAX,[EAX].FBits   {   }
      mov  EAX,[EAX]
      MOV  Znach,EAX
      end;
      ReplaceGrBt(Index, Dopoln.Size, Znach);
          end
     else begin   {     }
      Znach := Gran - Index;
      MovBit(0, Znach, Index, Dopoln.FBits, FBits );
      Value := Ostat - Gran;  {  ,    (<8 !!!)}
      if Value < 1 Then Exit;
      Znach := Dopoln.Nomer (Znach, Value);
      ReplaceGrBt(Gran, Value, Znach );
  end      end;
end;

procedure TStr_Bit.Copy ( Isx : TStr_Bit; Index,Count: Integer);
{   p  ,    Isx  }
{   Index   Count                                      }
var Value : Integer;
begin
  if Index >= Isx.Size then Error;
  Value := Isx.Size - Index;
  If  Value > Count Then Value := Count;
  SetSize(Value);
  if Value <> 0 then MovBit(Index, Value, 0, Isx.FBits, FBits );
end;

procedure TStr_Bit.CopyAllBit ( Isx : TStr_Bit);
 {   p    Isx  }
begin
  SetSize(Isx.Size);
  if Isx.Size <> 0 then MovBit(0, Isx.Size, 0, Isx.FBits, FBits );
end;

function TStr_Bit.Nomer(Nach : Integer; dln: byte) : Integer;    assembler;
 {      Dln       Nach. }
 {    ,    DLN       }
 {  .          - 32                  }
{  EDX -->    - Nach -   .     }
{  ECX -->    - dln  -     }
ASM
      CMP     CL,32
      JA      TStr_Bit.Error
      CMP     CL,0
      JE      TStr_Bit.Error
      MOV     CH,CL      {   }
      MOV     CL,DL      {   }
      CMP     EDX,0
      JL      TStr_Bit.Error
      PUSH    ESI
      mov     ESI,[EAX].FBits
      MOV     EAX,[EAX].FSize {        }
      PUSH    EBX
      XOR     EBX,EBX
      MOV     BL,CH
      SUB     EAX,EBX  {     }
      POP     EBX
      SUB     EAX,EDX
      JNS     @Obr_Nomer
      XOR     EAX,EAX   {   ,   0 }
      JMP     @NetBit
@Obr_Nomer:    {     -  }
      shr     EDX,3
      ADD     ESI,EDX
      and     cl,7
      cld
      LODSD            {p  }
      MOV     EDX,[ESI]
      SHRD    EAX,EDX,cl
      mov     cl,32
      sub     CL,CH
      rol     EAX,cl           {   }
      shr     EAX,cl
@NetBit:
      POP     ESI
END;

function TStr_Bit.Pos(SubS: TStr_Bit; Nach, Shag : Integer ): Integer;
 { p ,   p   p p p SubS; }
 {     Nach,   p         }
 {      Shag.                                  }
 {        btNotFound = -1         }
label end_pos, end_sr, E_POS;
var i, dl_sr, jkom, Komb_srav, Razm : Integer;
begin
   if Shag < 1 then Error;
   Razm := SubS.Size;
   if ( Size < Nach) or (Size - Nach < Razm) then goto E_POS;
   i := Nach;
   if Razm <= 32 then begin
     Komb_srav := SubS.Nomer(0,Razm);
      repeat
       if Nomer(i,Razm) = Komb_srav then goto end_pos;
       inc(i,Shag)
      until i > Size - Razm
                      end
                 else begin
     Komb_srav := SubS.Nomer(0,32);
      repeat
       if Nomer(i,32) = Komb_srav then begin
         dl_sr := Razm - 32;     jkom := 32;
          while dl_sr > 32 do               begin
           if Nomer(i+jkom,32) <> SubS.Nomer(jkom,32) then     goto end_sr;
           dec (dl_sr,32);  inc(jkom,32)    end;
          if Nomer(i+jkom,dl_sr) = SubS.Nomer(jkom,dl_sr) then goto end_pos
                                       end;
         end_sr: inc(i,Shag)
      until i > Size - Razm
                      end;  { Else }
E_POS:   i := btNotFound;
end_pos: Pos := i
end;    { TStr_Bit.Pos }

procedure TStr_Bit.Init_zn (Razm: Integer; Value: Byte);  assembler;
{  EDX -->    - Razm  -        }
{  ECX -->    - Value -   }
ASM
        PUSH    Self
        PUSH    EDX   // Razm
        PUSH    ECX  {Value}
        CALL    TStr_Bit.SetSize
        POP     EDX  {Value}
        POP     ECX  //Razm
        POP     Self
        CMP     ECX,1        // if Razm < 1 then Exit;
        JL      @EndInit
      PUSH  EDI
      MOV   EDI,[EAX].FBits
      ADD   ECX,7
      SHR   ECX,3      //   
      MOV   AL,DL
      CLD              //   
REP   STOSB
      POP   EDI
@EndInit:
END;

procedure TStr_Bit.Init_1 (Razm: Integer);   {    p  "1" }
begin  Init_zn(Razm,$FF)  end;

procedure TStr_Bit.Init_0 (Razm: Integer);   {    p  "0" }
begin  Init_zn(Razm,0)    end;

procedure TStr_Bit.BOOL( Dopoln : TStr_Bit; Vid_op: Byte);       assembler;
 {       ,        }
 {   Vid_op   p  p           }
 {      ,     }
 {      2                                      }
 {    Vid_op:                 }
 {        p AND   Vid_op:= btAND : Byte = 1;      }
 {        p XOR   Vid_op:= btXOR : Byte = 0;      }
 {        p OR    Vid_op:= btOR  : Byte = 2;      }
asm
    PUSH    ESI
    PUSH    EDI
    PUSH    EBX
    MOV     BL,CL             {  }
    mov     ESI,[EDX].FBits   {   }
    mov     EDI,[EAX].FBits   {     }
    MOV     ECX,[EAX].FSize
    CMP     ECX,[EDX].FSize
    JL      @BOLSH
    MOV     ECX,[EDX].FSize
@BOLSH:
    MOV     EDX,ECX           {     }
    ADD     ECX,31
    SHR     ECX,5    {     }
    cld
    PUSH    EAX
    CMP     BL,btOR
    JE      @ciklOR
    CMP     BL,btAND
    JE      @ciklAND

@ciklXOR:
    LODSD
    xor     EAX,[EDI]
    stosd
    loop    @ciklXOR
    JMP    @EndProc

@ciklOR:
    LODSD
    OR      EAX,[EDI]
    stosd
    loop    @ciklOR
    JMP    @EndProc

@ciklAND:
    LODSD
    AND     EAX,[EDI]
    stosd
    loop    @ciklAND

@EndProc:  POP    EAX
           POP    EBX
           POP    EDI
           POP    ESI
           PUSH   Self
           CALL   TStr_Bit.SetSize
           POP    Self
end;

procedure TStr_Bit.Mod2( Dopoln : TStr_Bit);       assembler;
 {       2                       }
asm
    PUSH    ESI
    PUSH    EDI
    mov     ESI,[EDX].FBits   {   }
    mov     EDI,[EAX].FBits   {     }
    MOV     ECX,[EAX].FSize
    CMP     ECX,[EDX].FSize
    JL      @BOLSH
    MOV     ECX,[EDX].FSize
@BOLSH:
    MOV     EDX,ECX           {     }
    ADD     ECX,31
    SHR     ECX,5    {     }
    cld
    PUSH    EAX
@ciklXOR:
    LODSD
    xor     EAX,[EDI]
    stosd
    loop    @ciklXOR

@EndProc:  POP    EAX
           POP    EDI
           POP    ESI
           PUSH   Self
           CALL   TStr_Bit.SetSize
           POP    Self
end;

procedure TStr_Bit.InvStrBit;  assembler;
 {   .  "1"  0   }
ASM
      mov     ECX,[EAX].FSize   {  }
      OR      ECX,ECX
      JZ      @EndInvStrBit     {      0 }
      PUSH    ESI
      mov     ESI,[EAX].FBits   {    }
      ADD     ECX,7
      SHR     ECX,3   {  }
@InvStr: NOT   BYTE PTR [ESI]
         INC   ESI
         LOOP  @InvStr
    POP    ESI
@EndInvStrBit:
END;

procedure TStr_Bit.Init_array (var Ust; Kol : Integer);
 {   p  c,p p Ust }
 {  p Kol  p  p p       }
var Dlina : Integer;
begin
   Dlina := Kol * 8;
   SetSize(Dlina);
   Move (Ust, FBits^,  Kol);
end;

procedure TStr_Bit.Val_array ( var Mass; Kol: Integer);  assembler;
 { p p Kol   p    }
 {    p  pp ,     }
 {                       }
ASM
    PUSH    ESI
    PUSH    EDI
    PUSH    EBX
    MOV     EDI,Mass            { p   p }
    mov     ESI,[EAX].FBits    { p   p  }
    MOV     EDX,[EAX].FSize    {     p }
    MOV     EBX,ECX     {     - Kol }
    cld
    MOV     ECX,EDX
    shr     ECX,3
    jz     @1byte
    CMP     ECX,EBX   {  p  pp }
    jb     @obr

    mov    ECX,EBX    {  }
 rep movsb
    jmp    @kon
@obr:
     sub    Ebx,Ecx    {  }
 rep movsb           { p   p }
@1byte:
     mov    ch,dl    { p    p }
     lodsb
     and    ch,7
     mov    cl,8
     sub    cl,ch
     shl    al,cl
     shr    al,cl
     stosb          { p  p 0-7  }
     dec    ebx
     jz     @kon
     mov    Ecx,Ebx
     xor    ax,ax
 rep stosb           {     }
@kon:
     POP    EBX
     POP    EDI
     POP    ESI
END;

function TStr_Bit.Kol_ed : Integer;                 assembler;
{    1    }
ASM
    PUSH    ESI
    PUSH    EBX
    MOV     EDX,[EAX].FSize  {  p}
    CMP     EDX,0
    JE      @NetBit
    MOV     EBX,btSumKod     {      }
    MOV     ESI,[EAX].FBits  {p  " p"}
    MOV     ch,dl
    SHR     EDX,3
    ADD     ESI,EDX        {        }
    INC     EDX            { -   }
    AND     ch,7
    mov     cl,8
    sub     cl,ch          { -   }
    xor     EAX,EAX
    STD
    LODSB                 {      }
    shl     AL,cl         {  ''    }
    MOV     ECX,EDX       { -   }
    XOR     EDX,EDX       {  - "1"    }
    jmp     @n_v
@Povt:   LODSB
@n_v:    mov     AL,[EBX+EAX]
         add     EDX,EAX
         loop    @Povt
@NetBit: MOV     EAX,EDX
    CLD
    POP     EBX
    pop     ESI
END;

{ TBitFile }

constructor TCustomBitFile.Create;
begin
  inherited Create;
  FRegOtkr := 0;
end;

procedure TBitFile.OpenBitFile(Name: string; Mode: word);
  { Name  -  ,  p  p p  }
  { Mode  - p p  }
begin
  if FRegOtkr <> 0 then FileError;
  FOrderBitRevers := False;
 if Mode = $3D00 { -- btOpenRead -- } then begin
  FFileHandle := FileOpen(Name, fmOpenReadWrite+fmShareDenyNone);
  if FFileHandle = INVALID_HANDLE_VALUE then raise Exception.Create('  ');
  FFileSize  := FileSeek(FFileHandle,0,2);
  if FFileSize <= 0 then begin
   CloseHandle(FFileHandle);
   FPosMax := 0;  raise Exception.Create('   ');
  end;
  try
    FMapHandle := CreateFileMapping(FFileHandle, nil, PAGE_READWRITE+SEC_COMMIT, 0, FFileSize, Nil);
         //     Pchar('Mapfile'+IntToStr(FFileHandle)) );
    if FMapHandle = 0 then raise Exception.Create('  ');
  finally   CloseHandle(FFileHandle)  end;
   try
    FData := MapViewOfFile(FMapHandle, FILE_MAP_WRITE, 0, 0, FFileSize);
    if FData = Nil then raise Exception.Create('   ');
   finally CloseHandle(FMapHandle)  end;
   {      8       }
   FPosMax := (FFileSize-1) * 8;
  end { ----       --- }
   else if Mode = $3C00 { --- btCreate --- } then begin
{$I-}
    AssignFile (FDisFile, Name);
    FileMode := 0;
    Rewrite(FDisFile,1);
{$I+}
    if IOResult <> 0 then FileError;  { p p    }
    FRazmBuf := btVnBuf;    FPosBuf := 0;
    GetMem(FBuff,FRazmBuf);
    FPosBufMax := FRazmBuf * 8;    FPosMax := 0;
   end {       }
   else FileError;
  FRegOtkr := Mode;    FPosition := 0;
  FStateI0 := btOK;
end;

procedure TCustomBitFile.FileError;
begin
  raise EFileBitError.Create('   ');
end;

procedure TCustomBitFile.FileErrorZacr;
begin
  raise EFileBitZacr.Create(' p    ')
end;

destructor TCustomBitFile.Destroy;
Begin
  if FRegOtkr <> 0 Then CloseBitFile;
  inherited Destroy;
end;

procedure TBitFile.CloseBitFile;
Var Dlina : Integer;
begin
  if FRegOtkr = 0 Then Exit;
  if FRegOtkr = btOpenRead then  UnmapViewOfFile(FData)
    else begin {  ,     }
    dlina := (FPosBuf + 7) div 8;
{$I-}
    if dlina <> 0 then begin
       if FOrderBitRevers then OrderBit(FBuff,dlina);
       BlockWrite(FDisFile, FBuff^, Dlina);
                       end;
{$I+}
    if IOResult <> 0 then FileErrorZacr ;
    CloseFile(FDisFile);
    FreeMem(FBuff,FRazmBuf);
    end;
  SetSize(0);
  FRegOtkr := 0;
  FStateI0 := btEndFile;
end;

procedure TBitFile.ChangeOrderBit;
begin
  if FRegOtkr = 0 then FileError;
  FOrderBitRevers := not FOrderBitRevers;
  if FRegOtkr = btOpenRead then OrderBit(FData,FFileSize);
end;

function TBitFile.ReadStr(Count:Integer): word;
   {  Count  p    }
Var NextPoz, RazmStr : integer;
begin
 if (FRegOtkr <> btOpenRead) or (FPosition >= FPosMax)
    then begin SetSize(0);
               FStateI0 := btEndFile;
               Result := btEndFile    end
    else begin
      NextPoz := FPosition + Count;
      If NextPoz > FPosMax Then RazmStr := FPosMax - FPosition
                           Else RazmStr := Count;
      SetSize(RazmStr);
      MovBit( FPosition, RazmStr, 0, FData, FBits );
      inc ( FPosition, RazmStr );
      Result := FStateI0          end
end;

function TBitFile.ReadNomer(Dln:byte): Integer;
   {     DLN      - }
var Itog, NextPoz, RazmStr : Integer;
begin
 if (Dln >32)or (Dln =0) then Error;
 if (FRegOtkr <> btOpenRead)or(FPosition >= FPosMax)
   then begin FStateI0 := btEndFile; Itog := 0; end
   else begin
    NextPoz := FPosition + Dln;
    If NextPoz > FPosMax Then RazmStr := FPosMax - FPosition
                         Else RazmStr := Dln;
    MovBit( FPosition, RazmStr, 0, FData, @Itog );

    inc ( FPosition, RazmStr );
    if Dln<>32 then begin
     ASM
     MOV EAX,Itog
     mov cl,dln
     mov EDX,1
     SHL EDX,cl
     DEC EDX
     AND EAX,EDX
     MOV Itog,EAX
   END end end;
 Result := Itog;  
end;

function TBitFile.ReadBit: Byte;
   {    ,   >1 =>  -  }
var NK : Integer;   RezOp : Byte;   AdrBuf : PByte;
begin
 if (FRegOtkr <> btOpenRead) or (FPosition >= FPosMax)
    then begin FStateI0 := btEndFile;
               Result := btEndFile        end
    else begin
      NK := FPosition;   AdrBuf := FData;
      inc(FPosition);
      ASM   {    }
        MOV     EDX,NK
        MOV     EAX,AdrBuf
        BT      [EAX],EDX
        SBB     EAX,EAX
        AND     EAX,1
        MOV     RezOp,AL
      END;
      FStateI0 := btOK;           Result := RezOp
end     end;

function TBitFile.VnWriteBuf(Count: Integer; AdrIsx:PByte): Word;
var Kol, EndBuf, PozStr, Count_out : Integer;
begin
   if FRegOtkr = 0 then FileError;
   if FRegOtkr = btCreate then begin
      EndBuf := FPosBuf + Count;   PozStr := 0;  Count_out := Count;
      WHILE EndBuf >= FPosBufMax do begin
      {   p   p }
         kol := FPosBufMax - FPosBuf;
         MovBit(PozStr, Kol, FPosBuf, AdrIsx, FBuff);
{$I-}
         if FOrderBitRevers then OrderBit(FBuff,FRazmBuf);
         BlockWrite(FDisFile,FBuff^,FRazmBuf);
{$I+}
         if IOResult <> 0  then begin FStateI0 := btOchBB;
                                      Result := btOchBB;
                                      Exit                  end;
         Inc ( PozStr, Kol );   FPosBuf := 0;
         dec ( Count_out, Kol );
         dec ( EndBuf, FPosBufMax );
       END;
      inc(FPosition,Count);  {     }
      inc(FPosMax,Count);    { p  }
      FStateI0 := btOK;
      MovBit(PozStr, Count_out, FPosBuf, AdrIsx, FBuff);
      inc(FPosBuf, Count_out );
      Result := btOk
    end
    else Result := btNevReg;
end;

function TBitFile.WriteStr: word;
   {  p     }
begin
  WriteStr := VnWriteBuf(Size, FBits);
end;

function TBitFile.WriteNomer(Zn:integer; Dln:byte): word;
{     DLN      -  }
begin
  if Dln > 32 then WriteNomer := btNevReg
              else WriteNomer := VnWriteBuf(Dln, @Zn);
end;

function TBitFile.WriteBit(Zn:byte): word;
   {  Zn     }
var NK : Integer;     AdrBuf : PByte;
  begin
  Nk := btNevReg;
  if FRegOtkr = 0 then FileError;
   if FRegOtkr = btCreate then begin
      inc(FPosition);  {     }
      inc(FPosMax);    { p  }
      Nk := FPosBuf;    AdrBuf := FBuff;
      ASM               //    
        MOV     EDX,Nk
        MOV     EAX,AdrBuf
        mov     CL,Zn
        OR      CL,CL
        JZ      @@2
        BTS     [EAX],EDX
        jmp     @@2P
@@2:    BTR     [EAX],EDX
@@2P:
      END;
      inc(FPosBuf);     //    
      Nk := btOk;
      if FPosBuf = FPosBufMax then begin  { p   }
{$I-}
         if FOrderBitRevers then OrderBit(FBuff,FRazmBuf);
         BlockWrite(FDisFile,FBuff^,FRazmBuf);
{$I+}
         FPosBuf := 0;
         if IOResult <> 0  then Nk := btOchBB;
                              end   end;
   Result := Nk
end;

function TBitFile.SeekStr(Polog : Integer): word;
   {         Pos }
begin
 if FRegOtkr = btOpenRead then begin
  if (Polog < FPosMax) and (Polog >= 0 )
    Then begin FPosition := Polog; SeekStr := btOk  end {     p  }
    else begin SeekStr := btEndFile; FPosition := FPosMax  end
  end
 else SeekStr := btNevReg
end;

function TBitFile.SizeOfFile : longint;
   { p  pp    }
begin  SizeOfFile := FPosMax;
end;

constructor TBitFile.Create;
begin
  inherited Create;
end;

destructor TBitFile.Destroy;
begin
  inherited Destroy;
end;

{ TBitFileLong }

procedure TBitFileLong.ChangeOrderBit;
begin
  if FRegOtkr = 0 then FileError;
  FOrderBitRevers := True;
  if FRegOtkr = btOpenRead then OrderBit(FBuff,FRazmBuf);
end;

procedure TBitFileLong.CloseBitFile;
Var Dlina : Int64;
begin
  if FRegOtkr = 0 Then Exit;
  if FRegOtkr = btCreate then begin
    dlina := (FPosBuf + 7) div 8;
{$I-}
    if dlina <> 0 then begin
       if FOrderBitRevers then OrderBit(FBuff,dlina);
       BlockWrite(FDisFile,FBuff^,Dlina);
                       end;
{$I+}
    if IOResult <> 0 then FileErrorZacr
                              end;
  CloseFile(FDisFile);
  FreeMem(FBuff,FRazmBuf);
  SetSize(0);
  FRegOtkr := 0;
  FStateI0 := btEndFile;
end;

constructor TBitFileLong.Create;
begin
  inherited Create;
end;

destructor TBitFileLong.Destroy;
begin
  inherited Destroy;
end;

procedure TBitFileLong.OpenBitFile(Name: string; Mode: word; BufSize: Integer);
var Kol: Integer;
begin
  if FRegOtkr <> 0 then FileError;
  FOrderBitRevers := False;
{$I-}
  AssignFile (FDisFile, Name);
  FileMode := 0;
   case  Mode of
    $3C00 {btCreate } : Rewrite(FDisFile,1);
    $3D00 {btOpenRead}: Reset(FDisFile,1);
   else FileError
   end; { case }
{$I+}
  if IOResult <> 0 then FileError;  { p p    }
    If BufSize < bt8 then FRazmBuf := bt8
                     else FRazmBuf := ( (BufSize+1) div bt8) * bt8;
    FRegOtkr := Mode;    FPosition := 0;    FPosBuf := 0;
    GetMem(FBuff,FRazmBuf);
    if Mode = btOpenRead then begin
{$I-}
       FPosMax := FileSize(FDisFile)* 8;   {     }
       BlockRead(FDisFile,FBuff^,FRazmBuf, Kol);
{$I+}
       if IOResult <> 0 then FileError;
       FPosBufMax := Kol * 8;
                              end
                         else begin
       FPosMax := 0;   FPosBufMax := FRazmBuf * 8
                              end;
     FStateI0 := btOK;
end;

function TBitFileLong.ReadBit: Byte;
   {    ,   >1 =>  -  }
var NK : Integer;   RezOp : Byte;   AdrBuf : PByte;
begin
 if (FRegOtkr <> btOpenRead) or (FPosition >= FPosMax)
    then begin FStateI0 := btEndFile;
               Result := btEndFile        end
    else begin
      if FPosBuf >= FPosBufMax then begin
{$I-}                                {      }
        BlockRead(FDisFile,FBuff^,FRazmBuf,NK);
        if FOrderBitRevers then OrderBit(FBuff,FRazmBuf);
{$I+}
        FPosBufMax := NK * 8;     FPosBuf := 0;
        if IOResult <> 0 then begin FPosBufMax := 0;
                                    FStateI0 := btOchBB;
                                    Result := btOchBB;
                                    Exit              end
                                    end;
      NK := FPosBuf;           inc(FPosBuf);
      AdrBuf := FBuff;         inc(FPosition);
      ASM   {    }
        MOV     EDX,NK
        MOV     EAX,AdrBuf
        BT      [EAX],EDX
        SBB     EAX,EAX
        AND     EAX,1
        MOV     RezOp,AL
      END;
      FStateI0 := btOK;           Result := RezOp
end     end;

function TBitFileLong.ReadNomer(Dln: byte): Integer;
   {     DLN      - }
var Itog : Integer;
begin
 if (Dln >32) or (Dln =0) then Error;
 if (FRegOtkr <> btOpenRead)or(FPosition >= FPosMax)
   then begin FStateI0 := btEndFile; Itog := 0 end 
   else begin VnReadBuf(Dln, @Itog);
    if Dln<>32 then begin
     ASM
     MOV EAX,Itog
     mov cl,dln
     mov EDX,1
     SHL EDX,cl
     DEC EDX
     AND EAX,EDX
     MOV Itog,EAX
   END end end;
 Result := Itog;  
end;

function TBitFileLong.ReadStr(Count: Integer): word;
   {  Count  p    }
begin
 if (FRegOtkr <> btOpenRead) or (FPosition >= FPosMax)
    then begin SetSize(0);
               FStateI0 := btEndFile;
               Result := btEndFile    end
    else begin
       SetSize(Count);
       SetSize( VnReadBuf(Count, FBits) );  //   ,    
       Result := FStateI0          end
end;

function TBitFileLong.SeekStr(Polog: Int64): word;
   {         Pos }
var BitPol : Int64;  Nk : Integer;
begin
 if FRegOtkr = btOpenRead then begin
  if Polog < FPosMax Then
  begin {     p  }
   BitPol := Polog - FPosition + FPosBuf;
     if (BitPol < 0) or (BitPol > FPosBufMax)
        then begin {      }
          BitPol := (Polog div (FRazmBuf*8)) * FRazmBuf;
{$I-}
          Seek(FDisFile,BitPol);
         if IOResult <> 0  then FileError
                           else begin
            BlockRead(FDisFile,FBuff^,FRazmBuf,NK);
            if FOrderBitRevers then OrderBit(FBuff,FRazmBuf);
{$I+}
   if IOResult = 0 then begin FPosBufMax := NK * 8;
                              FPosBuf := Polog - BitPol * 8   end
                   else FileError
             end                end
        else FPosBuf := BitPol; { C  p p }
   FPosition := Polog; SeekStr := btOk
  end
  else begin
   FPosition := FPosMax;
   SeekStr := btEndFile
  end end
else SeekStr := btNevReg
end;

function TBitFileLong.SizeOfFile: Int64;
   { p  pp    }
begin  SizeOfFile := FPosMax;
end;

function TBitFileLong.VnReadBuf(Count: Integer; AdrItog: PByte): Word;
var Kol, NK, EndBuf, PozStr, Count_out, Dln_sh : Integer;
begin
 if FRegOtkr <> btOpenRead then FileError;
  EndBuf := FPosBuf + Count;   PozStr := 0;
  Count_out := Count;          Dln_sh := 0;
  WHILE EndBuf >= FPosBufMax do begin
     Kol := FPosBufMax - FPosBuf;
     MovBit(FPosBuf,kol,0,FBuff,AdrItog);
{$I-}
     BlockRead(FDisFile,FBuff^,FRazmBuf,NK);
     if FOrderBitRevers then OrderBit(FBuff,FRazmBuf);
{$I+}
     dec ( Count_out, Kol );       Inc ( Dln_sh,Kol );
     dec ( EndBuf, FPosBufMax );   FPosBuf := 0;
     If (FRazmBuf <> NK) then begin {    }
        FPosBufMax := NK * 8;     EndBuf := -1;
        if IOResult <> 0 then begin Result := Dln_sh;
                                    FStateI0 := btOchBB;
                                    Exit              end;
        if Count_out > FPosBufMax then Count_out := FPosBufMax;
       end;
     Inc ( PozStr, Kol );          
    end;
    MovBit(FPosBuf,Count_out, PozStr, FBuff,AdrItog);
    Inc ( Dln_sh,Count_out );
    inc(FPosition,Dln_sh);         inc(FPosBuf,Count_out);
    FStateI0 := btOK;              Result := Dln_sh;
end;

function TBitFileLong.VnWriteBuf(Count: Integer; AdrIsx: PByte): Word;
var Kol, EndBuf, PozStr, Count_out : Integer;
begin
   if FRegOtkr = 0 then FileError;
   if FRegOtkr = btCreate then begin
      EndBuf := FPosBuf + Count;   PozStr := 0;  Count_out := Count;
      WHILE EndBuf >= FPosBufMax do begin
      {   p   p }
         kol := FPosBufMax - FPosBuf;
         MovBit(PozStr, Kol, FPosBuf, AdrIsx, FBuff);
{$I-}
         if FOrderBitRevers then OrderBit(FBuff,FRazmBuf);
         BlockWrite(FDisFile,FBuff^,FRazmBuf);
{$I+}
         if IOResult <> 0  then begin FStateI0 := btOchBB;
                                      Result := btOchBB;
                                      Exit                  end;
         Inc ( PozStr, Kol );   FPosBuf := 0;
         dec ( Count_out, Kol );
         dec ( EndBuf, FPosBufMax );
       END;
      inc(FPosition,Count);  {     }
      inc(FPosMax,Count);    { p  }
      FStateI0 := btOK;
      MovBit(PozStr, Count_out, FPosBuf, AdrIsx, FBuff);
      inc(FPosBuf, Count_out );
      Result := btOk
    end
    else Result := btNevReg;
end;

function TBitFileLong.WriteBit(Zn: byte): word;
   {  Zn     }
var NK : Integer;     AdrBuf : PByte;
  begin
  Nk := btNevReg;
  if FRegOtkr = 0 then FileError;
   if FRegOtkr = btCreate then begin
      inc(FPosition);  {     }
      inc(FPosMax);    { p  }
      Nk := FPosBuf;    AdrBuf := FBuff;
      ASM               //    
        MOV     EDX,Nk
        MOV     EAX,AdrBuf
        mov     CL,Zn
        OR      CL,CL
        JZ      @@2
        BTS     [EAX],EDX
        jmp     @@2P
@@2:    BTR     [EAX],EDX
@@2P:
      END;
      inc(FPosBuf);     //    
      Nk := btOk;
      if FPosBuf >= FPosBufMax then begin  { p   }
{$I-}
         if FOrderBitRevers then OrderBit(FBuff,FRazmBuf);
         BlockWrite(FDisFile,FBuff^,FRazmBuf);
{$I+}
         FPosBuf := 0;
         if IOResult <> 0  then Nk := btOchBB;
                              end   end;
   Result := Nk
end;

function TBitFileLong.WriteNomer(Zn: integer; Dln: byte): word;
{     DLN      -  }
begin
  if Dln > 32 then WriteNomer := btNevReg
              else WriteNomer := VnWriteBuf(Dln, @Zn);
end;

function TBitFileLong.WriteStr: word;
   {  p     }
begin
  WriteStr := VnWriteBuf(Size, FBits);
end;

initialization
  btTabob := @Tabob;
  btSumKod := @SumKod;
end.